'&&&&&&&&&&&&&&&& PROGRAMA   D I N A Q U A  &&&&&&&&&&&&&&&&&&&&&
' by Jose M. Paruelo y Osvaldo E. Sala
'    Departamento de Ecologia - Facultad de Agronomia
'    Universidad de Buenos Aires
 
'This programm simulate the water dynamic in arid environments of Patagonia
'This version supposed a similar biomass dynamics for shrubs and grasses
'The transpiration depletion is a function of the effective water content

'****************** VARIABLES DIM ***************
DIM EVAPSEM(60)
DIM TRANSPSEM(60)
DIM DRAINSEM(60)
DIM PPTASEM(60)
DIM MAXCH(6, 60)
DIM MINCH(6, 60)
DIM CHTOT(60)
DIM CHEFPAS(60)
DIM CHEFARB(60)
DIM DRENACUM(20)
DIM EVACUM(20)
DIM TRANSACUM(20)
DIM TRANSACUMpas(20)
DIM TRANSACUMarb(20)
DIM TRANSPSEMPAS(60)
DIM TRANSPSEMARB(60)
DIM PPTACUM(20)
DIM VARALM(20)
DIM ANNEV(20)
DIM ANNTRANS(20)
DIM ANNDREN(20)
DIM ANNPP(20)
DIM EVPOTACUM(20)
DIM PTAG(6, 52)
DIM EST(10)
DIM DRAICPAS(10)
DIM DRAICARB(10)
DIM PEDREG(10)
DIM CTE1(6)
DIM CTE2(6)
DIM FC(6)
DIM PMP(6)
DIM CHEST(6)
DIM SATFLUX(10)
DIM TRANSPPAS(10)
DIM TRANSPARB(10)
DIM TRANSP(10)
DIM MINCHEST(10)
DIM MAXCHEST(10)
DIM AW(10)

10            
'********************** INITIAL CONDITIONS *****************
'---------------------------------
'NUMBER AND THICKNESS OF SOIL LAYERS (in mm)
 
NEST = 6
EST(1) = 100
EST(2) = 100
EST(3) = 200
EST(4) = 400
EST(5) = 400
EST(6) = 800
 
'---------------------------------
'ROOT DENSITY OF EACH SOIL LAYER (in proportion)
 
DRAICPAS(1) = .43     'Grasses
DRAICPAS(2) = .24
DRAICPAS(3) = .22
DRAICPAS(4) = .1
DRAICPAS(5) = .007
DRAICPAS(6) = 0
 
DRAICARB(1) = .045     'Shrubs
DRAICARB(2) = .084
DRAICARB(3) = .244
DRAICARB(4) = .51
DRAICARB(5) = .108
DRAICARB(6) = 0
 
 
'---------------------------------
'PARAMETERS TO EVAPORATION CALCULATION
 
KI = .05                     'Unsaturated Conductivyty at FC
 
AL = 2.4426 + 17.194 * KI    'Prop. coef of the EV/SQR Time relation
U = 2.5887 + 62.903 * KI     'Parameter for the duration of Phase I

WB = 1
'---------------------------------
'TRANSPIRATION PARAMETERS
 
DEMTEST = 5.93
 
TTESTPAS = 10.95
TTESTARB = 7.68
 
BIOMAXPAS = 56
BIOMINPAS = 20
BIOMAXARB = 20
BIOMINARB = 0
LIMAWPAS = 4.8
LIMAWARB = 3.8
 
DJPMAXPAS = 365
DJIMINPAS = 135
DJFMINPAS = 273
 
PENDCRECPAS = (BIOMAXPAS - BIOMINPAS) / (DJPMAXPAS - DJFMINPAS)
PENDDESCPAS = (BIOMAXPAS - BIOMINPAS) / DJIMINPAS

DJPMAXARB = 365
DJIMINARB = 135
DJFMINARB = 273

PENDCRECARB = (BIOMAXARB - BIOMINARB) / (DJPMAXARB - DJFMINARB)
PENDDESCARB = (BIOMAXARB - BIOMINARB) / DJIMINARB

'---------------------------------
'SOIL PARAMETERS
 
PEDREG(1) = 21
PEDREG(2) = 21
PEDREG(3) = 21
PEDREG(4) = 40
PEDREG(5) = 40
PEDREG(6) = 40
FOR I = 1 TO 3
CTE1(I) = 3.237 + .0071 * PEDREG(I) + .000357 * (PEDREG(I) ^ 2)
CTE2(I) = -(.623 + .0023 * PEDREG(I) + .000157 * (PEDREG(I) ^ 2))
NEXT I
CTE1(4) = 9.4
CTE2(4) = -.98
CTE1(5) = 4.1
CTE2(5) = -.97
CTE1(6) = 4.1
CTE2(6) = -.97
 
FOR I = 1 TO 6
FC(I) = ((LOG(.01) - CTE1(I)) / CTE2(I)) * EST(I) / 100
NEXT I
 
FOR I = 1 TO 6
PMP(I) = ((LOG(5.9) - CTE1(I)) / CTE2(I)) * EST(I) / 100
NEXT I
 
FOR I = 1 TO NEST
CHEST(I) = FC(I)
NEXT I
 
'---------------------------------
'CLIMATICS FILES
 
CLIMDAT$ = "c:\daqprog\riomayo\pptarm.prn"
TEMPDAT$ = "c:\daqprog\riomayo\temradrm.prn"
TRUN = 367            'Running time
 
 
' ***********************  PRESENTATION **************************
CLS
PRINT "Water Dynamic Model for the Patagonian Arid Steppe"
PRINT "by: Jose M.Paruelo & Osvaldo E. Sala"
PRINT "IFEVA - Dpto.Ecologia"
PRINT "Fac. Agronomia - University of Buenos Aires"
INPUT Q$
CLS :
CLOSE #2
PRINT "Print (1),Screen (2) or Save (3)"
INPUT AA
ON AA GOTO 60, 65, 70
60 FILEN$ = "LPT1:": GOTO 90
65 FILEN$ = "SCRN:": GOTO 90
70 INPUT "Name of output file:"; FILEN$
90 OPEN FILEN$ FOR OUTPUT AS #2
INPUT "Modifies initial conditions (Y/N) "; Q$
IF Q$ = "y" OR Q$ = "Y" THEN GOSUB 15000
CLS
PRINT "INITIAL CONDITIONS "
PRINT : PRINT "Climatic Files: "; CLIMDAT$, TEMPDAT$
PRINT : PRINT "Running time (d): "; TRUN
PRINT : PRINT "No.of soil layers: "; NEST
PRINT : PRINT "Soil conditions: "
PRINT : PRINT "       Th.(mm) %Stone    F.C. (mm)    W.P (mm)    Initial WC (mm)"
FOR I = 1 TO NEST
PRINT "# "; I; "  "; EST(I); "   "; PEDREG(I); "    "; FC(I); "    "; PMP(I); "     "; CHEST(I)
NEXT I
INPUT Q$
CLS
PRINT "Root proportion by layer:"
PRINT "Lay.  Grasses   Shrubs"
FOR I = 1 TO NEST
PRINT USING "##"; I;
PRINT USING "######.##"; DRAICPAS(I);
PRINT USING "######.##"; DRAICARB(I)
NEXT I
PRINT
PRINT "Maximun grasses Transpiration (g g-1 d-1) : "; TTESTPAS
PRINT "Maximun shrubs Transpiration  (g g-1 d-1) : "; TTESTARB
PRINT
PRINT "Threshold effective available water for grasses: "; LIMAWPAS
PRINT "Threshold effective available water for shrubs : "; LIMAWARB

INPUT Q$: CLS
PRINT "Maximun Grass biomass (g m-2): "; BIOMAXPAS
PRINT "Minimun Grass biomass        : "; BIOMINPAS
PRINT "Maximun Shrubs biomass       : "; BIOMAXARB
PRINT "Maximun Shrubs biomass       : "; BIOMINARB
PRINT : PRINT "Julian day of maximun biomass (grasses): "; DJPMAXPAS
PRINT "Julian day for the end   of growing season (grasses): "; DJIMINPAS
PRINT "Julian day for the start of growing season (grasses): "; DJFMINPAS
PRINT : PRINT "Julian day of maximun biomass (shrubs): "; DJPMAXARB
PRINT "Julian day for the end   of growing season (shrubs): "; DJIMINARB
PRINT "Julian day for the start of growing season (shrubs): "; DJFMINARB

INPUT Q$
 
900
'--------------------------------
J = 0
GOSUB 19000
GOSUB 18000
 
FCT = (FC(1) + FC(2) + FC(3) + FC(4)) / 8

FOR I = 1 TO 6
MAXAWPAS = MAXAWPAS + (DRAICPAS(I) * (FC(I) - PMP(I)) / EST(I))
MAXAWARB = MAXAWARB + (DRAICARB(I) * (FC(I) - PMP(I)) / EST(I))
NEXT I
MAXAWPAS = MAXAWPAS * 100
MAXAWARB = MAXAWARB * 100
CLOSE #1
CLOSE #3
OPEN CLIMDAT$ FOR INPUT AS #1
OPEN TEMPDAT$ FOR INPUT AS #3
 
 
'********************** SIMULATION ***************************
 
CLS
JC = 1: F = 1: Y = 0
YT = TRUN / 365
1000
LOCATE 10, 10: PRINT "============== RUNNING ================"
LOCATE 12, 12: PRINT "YEAR No.: "; Y + 1
INPUT #1, CYEAR, DIAJ, PP
INPUT #3, JDAY, TEMP, RAD

IF JDAY = DIAJ THEN GOTO 1002 ELSE 1001
1001 PRINT "WARNING!!!, PROBLEMS WITH THE CLIMATIC FILES"
PRINT "   "; J: INPUT Q$
1002 HEL = 100
PPYEAR = PPYEAR + PP
PPTAYEAR = PPTAYEAR + PP
'++++++++++++++++++++++++ SATURATED FLUXES +++++++++++++++++++++
SATFLUX(1) = 0: DRAINAGE = 0
IF PP > 0 THEN GOTO 1003 ELSE GOTO 1005
 
1003 CHEST(1) = CHEST(1) + PP
SATFLUX(1) = CHEST(1) - FC(1): IF SATFLUX(1) < 0 THEN SATFLUX(1) = 0
IF CHEST(1) > FC(1) THEN CHEST(1) = FC(1)
 
FOR H = 2 TO NEST
 
CHEST(H) = CHEST(H) + SATFLUX(H - 1)
SATFLUX(H) = CHEST(H) - FC(H): IF SATFLUX(H) < 0 THEN SATFLUX(H) = 0
IF CHEST(H) > FC(H) THEN CHEST(H) = FC(H)
 
NEXT H
 
DRAINAGE = SATFLUX(NEST)
 
IF SATFLUX(1) = 0 GOTO 1005
SES1 = 0
SES2 = 0
T = 0
 
1005
 
GOSUB 18000
 
GOSUB 19000
 
1010 '++++++++++  EVAPORATION ++++++++++++++++++++++++++++
 
'Calculation from Ritchie 1972
 
IF PP > 0 THEN HEL = 0
PSI = .47 + .01 * TEMP
RT = (.25 + .5 * HEL / 100) * RAD
RN = .649 * RT - 23
ESO = 1.26 * PSI * RN * 10 / 580
IF SES1 < U GOTO 1100
IF PP >= SES2 GOTO 1050
T = T + 1
ES = AL * SQR(T) - AL * SQR(T - 1)
IF PP > 0 GOTO 1030
IF ES > ESO THEN ES = ESO
GOTO 1040
1030 ESX = .8 * PP
IF ESX <= ES THEN ESX = ES + PP
IF ESX > ESO THEN ESX = ESO
ES = ESX
1040 SES2 = SES2 + ES + PP
T = (SES2 / AL) ^ 2
GOTO 1200
1050 P = PP - SES2
SES1 = U - P
IF P > U THEN SES1 = 0
GOTO 1120
1100 IF PP >= SES1 GOTO 1110 ELSE 1115
1110 SES1 = 0: GOTO 1120
1115 SES1 = SES1 - PP
1120 SES1 = SES1 + ESO
IF SES1 > U THEN 1150 ELSE 1180
1150 ES = ESO - .4 * (SES1 - U)
SES2 = .6 * (SES1 - U)
T = (SES2 / AL) ^ 2
GOTO 1200
1180 ES = ESO
1200  EVPOT = ESO: EVACT = ES
evpotyear = evpotyear + EVPOT

'++++++++++++++++++++++++TRANSPIRATION++++++++++++++++++++++++++
'GRASSES TRANSPIRATION

TPOTPAS = (TTESTPAS * EVPOT) / DEMTEST
 
IF DIAJ < DJIMINPAS THEN BIOMASA = BIOMAXPAS - PENDDESCPAS * (DIAJ)
IF DIAJ > DJIMINPAS AND DIAJ < DJFMINPAS THEN BIOMASA = BIOMINPAS
IF DIAJ > DJFMINPAS THEN BIOMASA = BIOMINPAS + PENDCRECPAS * (DIAJ - DJFMINPAS)
SLOPAST = TPOTPAS / LIMAWPAS
IF CHEFPAS < LIMAWPAS THEN SLOPAST = SLOPAST ELSE SLOPAST = 0
TREALPAS = (TPOTPAS - (SLOPAST * (LIMAWPAS - CHEFPAS))) * BIOMASA / 1000
IF TREALPAS < 0 THEN TREALPAS = 0

FOR I = 1 TO NEST
IF CHEFPAS = 0 THEN CHEFPAS = .0000001
TRANSPPAS(I) = TREALPAS * ((DRAICPAS(I) * AW(I) / EST(I)) / (CHEFPAS / 100))
NEXT I
 
'SHRUBS TRANSPIRATION

TPOTARB = (TTESTARB * EVPOT) / DEMTEST

IF DIAJ < DJIMINARB THEN BIOMASA = BIOMAXARB - PENDDESCARB * (DIAJ)
IF DIAJ > DJIMINARB AND DIAJ < DJFMINARB THEN BIOMASA = BIOMINARB
IF DIAJ > DJFMINARB THEN BIOMASA = BIOMINARB + PENDCRECARB * (DIAJ - DJFMINARB)
SLOPARB = TPOTARB / LIMAWARB
IF CHEFARB < LIMAWARB THEN SLOPARB = SLOPARB ELSE SLOARB = 0
TREALARB = (TPOTARB - (SLOPARB * (LIMAWARB - CHEFARB))) * BIOMASA / 1000
IF TREALARB < 0 THEN TREALARB = 0

FOR I = 1 TO NEST
IF CHEFARB = 0 THEN CHEFARB = .0000001
TRANSPARB(I) = TREALARB * ((DRAICARB(I) * AW(I) / EST(I)) / (CHEFARB / 100))
NEXT I
 
TRANSP(1) = TRANSPPAS(1) + TRANSPARB(1)
 
PET = TRANSP(1) + EVACT
 
IF PET <= AW(1) GOTO 1300
EVACT = EVACT * (AW(1) / PET)
TRANSP(1) = TRANSP(1) * (AW(1) / PET)
IF TRANSP(1) <= 0 THEN GOTO 1300
TRANSPPAS(1) = TRANSP(1) * (TRANSPPAS(1) / (TRANSPPAS(1) + TRANSPARB(1)))
TRANSPARB(1) = TRANSP(1) * (TRANSPARB(1) / (TRANSPPAS(1) + TRANSPARB(1)))

1300 FOR I = 2 TO NEST
TRANSP(I) = TRANSPPAS(I) + TRANSPARB(I)
IF TRANSP(I) <= AW(I) THEN GOTO 1400
TRANSP(I) = AW(I)
TRANSPPAS(I) = TRANSP(I) * (TRANSPPAS(I) / (TRANSPPAS(I) + TRANSPARB(I)))
TRANSPARB(I) = TRANSP(I) * (TRANSPARB(I) / (TRANSPPAS(I) + TRANSPARB(I)))
1400 NEXT I
PRINT

' ++++++++++++++++ STATE VARIABLE UPDATE +++++++++++++++++
PPSEM = PPSEM + PP
EVACUM = EVACUM + EVACT
EVSEM = EVSEM + EVACT
DRENACUM = DRENACUM + DRAINAGE
DRENSEM = DRENSEM + DRAINAGE
EVYEAR = EVYEAR + EVACT + DRAINAGE
DRENYEAR = DRENYEAR + DRAINAGE
 
TRANSPTOT = 0
FOR I = 1 TO NEST
 
TRANSPTOT = TRANSPTOT + TRANSP(I)
 
NEXT I

transptotpas = 0
FOR I = 1 TO NEST
transptotpas = transptotpas + TRANSPPAS(I)
NEXT I

transptotarb = 0
FOR I = 1 TO NEST
transptotarb = transptotarb + TRANSPARB(I)
NEXT I
PRINT : PRINT "DIAJ      TRpas      TRarb        EVpot       EVact        PP  "
PRINT "---------------------------------------------------------------------------"
PRINT USING "####"; DIAJ;
PRINT USING "######.#####"; transptotpas; transptotarb; EVPOT; EVACT; PP
PRINT "^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^"
PRINT "    CH Ef pas     CH Ef arb      MAX AW pas    MAX AW arb"
PRINT "----------------------------------------------------------"
PRINT USING "######.#######"; CHEFPAS; CHEFARB; MAXAWPAS; MAXAWARB

TRANSACUM = TRANSACUM + TRANSPTOT
TRANSACUMpas = TRANSACUMpas + transptotpas
TRANSACUMarb = TRANSACUMarb + transptotarb
TRANSEM = TRANSEM + TRANSPTOT
transempas = transempas + transptotpas
transemarb = transemarb + transptotarb
TRANSYEAR = TRANSYEAR + TRANSPTOT
 
CHEST(1) = CHEST(1) - TRANSP(1) - EVACT
IF Q = 1 THEN MINCHEST(1) = CHEST(1)
IF Q = 1 THEN MAXCHEST(1) = CHEST(1)
IF CHEST(1) > MAXCHEST(1) THEN MAXCHEST(1) = CHEST(1)
IF CHEST(1) < MINCHEST(1) THEN MINCHEST(1) = CHEST(1)
     FOR I = 2 TO NEST
 
CHEST(I) = CHEST(I) - TRANSP(I)
IF Q = 1 THEN MINCHEST(I) = CHEST(I)
IF Q = 1 THEN MAXCHEST(I) = CHEST(I)
IF CHEST(I) > MAXCHEST(I) THEN MAXCHEST(I) = CHEST(I)
IF CHEST(I) < MINCHEST(I) THEN MINCHEST(I) = CHEST(I)
 
     NEXT I
 
IF F = 1 THEN GOSUB 23000
IF DIAJ = 365 THEN GOSUB 24000
IF Q = 7 THEN GOSUB 21000
IF F = 365 THEN GOSUB 22000
IF JC = TRUN THEN 8000
 
JC = JC + 1
F = F + 1
Q = Q + 1
 
GOTO 1000
2000 CLOSE #1
50000 CLS : END
'%%%%%%%%%%%%%%%%%%%%%%%  SUBRUTINES  %%%%%%%%%%%%%%%%%%%%%%%

15000 '********** INICIAL CONDITIONS MODIFICATION ***********
CLS
PRINT "INITIAL CONDITION"
PRINT : PRINT "If no change --> return": PRINT
LOCATE 5, 1: PRINT "Climatic files: "; CLIMDAT$; " "; : INPUT x$
IF x$ <> "" THEN CLIMDAT$ = x$
PRINT "               "; TEMPDAT$; " "; : INPUT x$
IF x$ <> "" THEN TEMPDAT$ = x$
PRINT "Running time: "; TRUN; " "; : INPUT x$: IF x$ <> "" THEN TRUN = VAL(x$)
PRINT "No.of soil layers (rigid): "; NEST
PRINT "Thickness of soil layers mm: "
FOR I = 1 TO NEST
PRINT "# "; I; "  "; EST(I); : INPUT x$: IF x$ <> "" THEN EST(I) = VAL(x$)
NEXT I
CLS
PRINT : PRINT "Stones % (only for the first 3 layers)"
FOR L = 1 TO 3
PRINT "# "; L; "  "; PEDREG(L); : INPUT x$: IF x$ <> "" THEN PEDREG(L) = VAL(x$)
NEXT L
FOR I = 1 TO 3
CTE1(I) = 3.237 + .0071 * PEDREG(I) + .000357 * (PEDREG(I) ^ 2)
CTE2(I) = -(.623 + .0023 * PEDREG(I) + .000157 * (PEDREG(I) ^ 2))
NEXT I
CTE1(4) = 9.4
CTE2(4) = -.98
CTE1(5) = 4.1
CTE2(5) = -.97
CTE1(6) = 4.1
CTE2(6) = -.97
 
FOR I = 1 TO 6
FC(I) = ((LOG(.01) - CTE1(I)) / CTE2(I)) * EST(I) / 100
NEXT I
 
FOR I = 1 TO 6
PMP(I) = ((LOG(5.9) - CTE1(I)) / CTE2(I)) * EST(I) / 100
NEXT I
 
PRINT : PRINT "Initial Water content mm"
PRINT "        FC"
FOR I = 1 TO NEST
PRINT "# "; I; "  "; FC(I); "  "; CHEST(I); : INPUT x$: IF x$ <> "" THEN CHEST(I) = VAL(x$)
NEXT I
CLS
PRINT : PRINT "Soil conditions: "
PRINT : PRINT "   Thick.(mm) %Stone    F.C. (mm)    W.P (mm)    Initial WC (mm)"
FOR I = 1 TO NEST
PRINT "# "; I; "  "; EST(I); "   "; PEDREG(I); "    "; FC(I); "    "; PMP(I); "     "; CHEST(I)
NEXT I
INPUT Q$: CLS
PRINT : PRINT "Root proportion by layer:"
PRINT "Lay.  Grasses  "
FOR I = 1 TO NEST
PRINT USING "##"; I;
PRINT USING "######.##"; DRAICPAS(I); : INPUT x$: IF x$ <> "" THEN DRAICPAS(I) = VAL(x$)

NEXT I
PRINT "Lay.  Shrubs  "
FOR I = 1 TO NEST
PRINT USING "##"; I;
PRINT USING "######.##"; DRAICARB(I); : INPUT x$: IF x$ <> "" THEN DRAICARB(I) = VAL(x$)

NEXT I
PRINT
PRINT "Maximun grasses Transpiration (g g-1 d-1) : "; TTESTPAS;
INPUT x$: IF x$ <> "" THEN TTESTPAS = VAL(x$)
PRINT "Maximun shrubs Transpiration  (g g-1 d-1) : "; TTESTARB;
INPUT x$: IF x$ <> "" THEN TTESTARB = VAL(x$)
PRINT
PRINT "Threshold effective available water  for grasses: "; LIMAWPAS;
INPUT x$: IF x$ <> "" THEN LIMAWPAS = VAL(x$)
PRINT "Threshold effective available water for shrubs : "; LIMAWARB;
INPUT x$: IF x$ <> "" THEN LIMAWARB = VAL(x$)
INPUT Q$: CLS
PRINT "Maximun Grass biomass (g m-2): "; BIOMAXPAS;
INPUT x$: IF x$ <> "" THEN BIOMAXPAS = VAL(x$)
PRINT "Minimun Grass biomass        : "; BIOMINPAS;
INPUT x$: IF x$ <> "" THEN BIOMINPAS = VAL(x$)
PRINT "Maximun Shrubs biomass       : "; BIOMAXARB;
INPUT x$: IF x$ <> "" THEN BIOMAXARB = VAL(x$)
PRINT "Minimun Shrubs biomass        : "; BIOMINARB;
INPUT x$: IF x$ <> "" THEN BIOMINARB = VAL(x$)
PRINT : PRINT "Julian day of maximun biomass (grasses): "; DJPMAXPAS;
INPUT x$: IF x$ <> "" THEN DJPMAXPAS = VAL(x$)
PRINT "Julian day for the end   of growing season (grasses): "; DJIMINPAS;
INPUT x$: IF x$ <> "" THEN DJIMINPAS = VAL(x$)
PRINT "Julian day for the start of growing season (grasses): "; DJFMINPAS;
INPUT x$: IF x$ <> "" THEN DJFMINPAS = VAL(x$)
PRINT : PRINT "Julian day of maximun biomass (SHRUBS): "; DJPMAXPAS;
INPUT x$: IF x$ <> "" THEN DJPMAXPAS = VAL(x$)
PRINT "Julian day for the end   of growing season (SHRUBS): "; DJIMINPAS;
INPUT x$: IF x$ <> "" THEN DJIMINPAS = VAL(x$)
PRINT "Julian day for the start of growing season (SHRUBS): "; DJFMINPAS;
INPUT x$: IF x$ <> "" THEN DJFMINPAS = VAL(x$)
PENDCRECPAS = (BIOMAXPAS - BIOMINPAS) / (DJPMAXPAS - DJFMINPAS)
PENDDESCPAS = (BIOMAXPAS - BIOMINPAS) / DJIMINPAS
PENDCRECARB = (BIOMAXARB - BIOMINARB) / (DJPMAXARB - DJFMINARB)
PENDDESCARB = (BIOMAXARB - BIOMINARB) / DJIMINARB
INPUT Q$: CLS

RETURN
 
18000 '********* TOTAL WATER CONTENT CALCULATION ******
 
CHTOTAL = 0
FOR I = 1 TO 4
CHTOTAL = CHTOTAL + CHEST(I)
NEXT I
CHTOTAL = CHTOTAL / 800 * 100

RETURN

19000 '******** AVAILABLE WATER CALCULATION *******************

AW(1) = CHEST(1) - PMP(1)
IF AW(1) < 0 THEN AW(1) = 0
IF AW(1) = 0 THEN CHEST(1) = PMP(1)
 
     FOR I = 2 TO NEST
 
AW(I) = CHEST(I) - PMP(I)
IF AW(I) < 0 THEN AW(I) = 0
IF AW(I) = 0 THEN CHEST(I) = PMP(I)
     NEXT I
CHEFPAS = 0
CHEFARB = 0
FOR I = 1 TO 6
CHEFPAS = CHEFPAS + (DRAICPAS(I) * (AW(I) / EST(I)))
CHEFARB = CHEFARB + (DRAICARB(I) * (AW(I) / EST(I)))
NEXT I
CHEFPAS = CHEFPAS * 100
CHEFARB = CHEFARB * 100

RETURN
 
21000 '************* WEEKLY VALUES CALCULATION ***************
 
SEM = SEM + 1
PPTASEM(SEM) = PPSEM
PPSEM = 0
EVAPSEM(SEM) = EVSEM
EVSEM = 0
TRANSPSEM(SEM) = TRANSEM
TRANSEM = 0
DRAINSEM(SEM) = DRENSEM
TRANSPSEMPAS(SEM) = transempas
transempas = 0
TRANSPSEMARB(SEM) = transemarb
transemarb = 0
DRENSEM = 0
FOR I = 1 TO NEST
MAXCH(I, SEM) = MAXCHEST(I)
MAXCHEST(I) = 0
MINCH(I, SEM) = MINCHEST(I)
MINCHEST(I) = 0
NEXT I
CHTOT(SEM) = CHTOTAL
CHEFPAS(SEM) = CHEFPAS
CHEFARB(SEM) = CHEFARB
Q = 0
RETURN
 
22000 ' ****************  ANNUAL VALUES ******************
Y = Y + 1
EVACUM(Y) = EVACUM
EVACUM = 0
TRANSACUM(Y) = TRANSACUM
TRANSACUM = 0
TRANSACUMpas(Y) = TRANSACUMpas
TRANSACUMpas = 0
TRANSACUMarb(Y) = TRANSACUMarb
TRANSACUMarb = 0
DRENACUM(Y) = DRENACUM
DRENACUM = 0
PPTACUM(Y) = PPYEAR
PPYEAR = 0
EVPOTACUM(Y) = evpotyear
evpotyear = 0
FITOTCH = 0
FOR I = 1 TO NEST
 
FITOTCH = FITOTCH + CHEST(I)
 
NEXT I
VARALM(Y) = FITOTCH - INTOTCH
F = 0
IF FILEN$ = "SCRN:" THEN GOTO 22090 ELSE 22100
22090
PRINT "Graphics? (Y/N): "; : INPUT Q$
IF Q$ = "y" OR Q$ = "Y" THEN GOSUB 55000
PRINT "Weekly results? (Y/N): "; : INPUT Q$
IF Q$ = "y" OR Q$ = "Y" THEN 22100 ELSE 22900
22100 IF FILEN$ = "SCRN:" AND Y > 1 THEN GOTO 22110
CLS : ct = 0
PRINT #2, "Week    Ev cum     Tr cum    Tr pas     Tr arb     Dr cum      Wc tot       PP"
PRINT #2, "------------------------------------------------------------------------"
22110 FOR T = 1 TO SEM
IF FILEN$ = "SCRN:" THEN GOTO 22140 ELSE 22150
22140 ct = ct + 1: IF ct <> 20 THEN GOTO 22150
INPUT Q$: ct = 0: CLS
PRINT #2, "Week    Ev cum     Tr cum    Tr pas     Tr arb     Dr cum      Wc tot       PP"
PRINT #2, "-----------------------------------------------------------------------"
22150 PRINT #2, USING "###"; T;
PRINT #2, USING "########.#"; EVAPSEM(T);
PRINT #2, USING "########.##"; TRANSPSEM(T);
PRINT #2, USING "########.##"; TRANSPSEMPAS(T);
PRINT #2, USING "########.##"; TRANSPSEMARB(T);
PRINT #2, USING "########.##"; DRAINSEM(T);
PRINT #2, USING "########.##"; CHTOT(T);
PRINT #2, USING "########.##"; PPTASEM(T)
NEXT T
IF FILEN$ = "SCRN:" THEN INPUT Q$
CLS : SCREEN 0
IF FILEN$ = "SCRN:" THEN GOTO 22590 ELSE 22600
22590 PRINT : PRINT "Water content and water potential by layer ? (Y/N)";
INPUT Q$
IF Q$ = "y" OR Q$ = "Y" GOTO 22600 ELSE 22900
22600
FOR I = 1 TO NEST
CLS : ct = 0
PRINT #2, "Layer : "; I
PRINT #2, "Week!  WC   !   WC   ! W P (MPa)   !  W P (MPa)    !"
PRINT #2, "_______max_____min_______max_____________min_____"
FOR T = 1 TO SEM
IF FILEN$ = "SCRN:" THEN GOTO 22690 ELSE 22700
22690 ct = ct + 1: IF ct <> 20 THEN GOTO 22700
IF FILEN$ = "SCRN:" THEN INPUT Q$
ct = 0: CLS
PRINT #2, "Layer : "; I
PRINT #2, "Week!  WC   !   WC   ! W P (MPa)   !  W P (MPa)    !"
PRINT #2, "_______max_____min_______max_____________min_____"
22700 PRINT #2, USING "###"; T;
PRINT #2, USING "######.##"; MAXCH(I, T);
PRINT #2, USING "######.##"; MINCH(I, T);
CHMAX = (MAXCH(I, T) * 100) / EST(I)
CHMIN = (MINCH(I, T) * 100) / EST(I)
ptagmax = EXP(CTE1(I) + CTE2(I) * CHMAX)
ptagmin = EXP(CTE1(I) + CTE2(I) * CHMIN)
PRINT #2, USING "#########.##"; ptagmax;
PRINT #2, USING "#########.##"; ptagmin
NEXT T
IF FILEN$ = "SCRN:" THEN INPUT Q$
NEXT I
CLS
22900 SEM = 0
RETURN
 
23000 ' ************************
INTOTCH = O
FOR I = 1 TO NEST
 
INTOTCH = INTOTCH + CHEST(I)
 
NEXT I
 
RETURN
 
 
24000 '******** CUMMULATIVES VALUES ON A ANNUAL BASIS **********
 
ANN = ANN + 1
ANNEV(ANN) = EVYEAR
ANNDREN(ANN) = DRENYEAR
ANNTRANS(ANN) = TRANSYEAR
ANNPP(ANN) = PPTAYEAR
 
EVYEAR = 0
DRENYEAR = 0
TRANSYEAR = 0
PPTAYEAR = 0
 
RETURN
 
8000 '**************** OUTPUT RESULTS ******************
CLS
SCREEN 0: WIDTH 80
PRINT #2, "YEAR  EVAP  TRANSP   TRPAS   TRARB  DRAIN  PPTA  EVPOT  STORAGE CHANGE "
PRINT "---------------------------------------------------------------------------"
PRINT
FOR Y = 1 TO YT
 
PRINT #2, USING "####"; Y;
PRINT #2, USING "####.##"; EVACUM(Y);
PRINT #2, USING "####.##"; TRANSACUM(Y);
PRINT #2, USING " ####.##"; TRANSACUMpas(Y);
PRINT #2, USING " ####.##"; TRANSACUMarb(Y);
PRINT #2, USING "####.##"; DRENACUM(Y);
PRINT #2, USING "####.##"; PPTACUM(Y);
PRINT #2, USING "######.##"; EVPOTACUM(Y);
PRINT #2, USING "######.##"; VARALM(Y)
IF FILEN$ = "SCRN:" THEN INPUT Q$ ELSE 8100
8100 NEXT Y
END

55000

57000 '************** RESULTS GRAPHICS ***********
CLS
PRINT "1) WEEKLY VALUES OF TRANSPIRATION"
PRINT
PRINT "2) WEEKLY VALUES OF TOTAL WATER CONTENT "
PRINT
PRINT "3) WEEKLY VALUES OF EVAPORATION"
PRINT
PRINT "4) WEEKLY MEAN WATER POTENTIAL FOR LAYERS 1 TO 3"
PRINT
PRINT "5) WEEKLY MEAN WATER POTENTIAL FOR LAYERS 4 TO 6"
PRINT
PRINT "6) CONTINUE"
PRINT : PRINT
INPUT Q
IF Q = 1 THEN GOTO 57500
IF Q = 2 THEN GOTO 80000
IF Q = 3 THEN GOTO 110000
IF Q = 4 THEN GOTO 120000
IF Q = 5 THEN GOTO 140000
IF Q = 6 THEN GOTO 160000

57500 CLS : SCREEN 1
Z = 40: ANT1 = 0: ANT2 = 0: ANT3 = 0: LIMINF = 0: LIMESC = 5
LOCATE 3, 1: PRINT "mm"
LOCATE 25, 30: PRINT "sem"
M = 0
LIMESC% = LIMESC
LOCATE 3, 1: PRINT LIMESC%
LOCATE 12, 1: PRINT "    -"
LIMINF% = LIMINF
LOCATE 22, 1: PRINT LIMINF%
LINE (40, 170)-(280, 20), , B
PSET (40, 170)
FOR J = 1 TO 51
DIVESC = 5 / 150
Z = Z + 4
IF J > 1 THEN GOTO 69500
LINE ((Z - 4), (170 - (TRANSPSEMPAS(J) - LIMINF) / DIVESC))-(Z, (170 - (TRANSPSEMPAS(J + 1) - LIMINF) / DIVESC)), 1
LINE ((Z - 4), (170 - (TRANSPSEMARB(J) - LIMINF) / DIVESC))-(Z, (170 - (TRANSPSEMARB(J + 1) - LIMINF) / DIVESC)), 2

GOTO 71000
69500 LINE ((Z - 4), (170 - (ANT1 - LIMINF) / DIVESC))-(Z, (170 - (TRANSPSEMPAS(J + 1) - LIMINF) / DIVESC)), 1
LINE ((Z - 4), (170 - (ANT2 - LIMINF) / DIVESC))-(Z, (170 - (TRANSPSEMARB(J + 1) - LIMINF) / DIVESC)), 2

71000 ANT1 = TRANSPSEMPAS(J + 1)
71500 ANT2 = TRANSPSEMARB(J + 1)

72500 NEXT J
A = (170 - (TRANSPSEMPAS(J) - LIMINF) / DIVESC) / 8: B = Z / 8
LOCATE A, B: PRINT "TR pas"
C = (170 - (TRANSPSEMARB(J) - LIMINF) / DIVESC) / 8: D = Z / 8
LOCATE C, D: PRINT "TR arb"
LOCATE 25, 1: PRINT "GRAFICO A IMPRESORA:^PRTSC"; : INPUT Q$
LOCATE 25, 1: INPUT Q$
SCREEN 0: WIDTH 80
GOTO 57000

80000
CLS : SCREEN 1
Z = 40: ANT1 = 0: LIMINF = 0: LIMESC = 14
LOCATE 3, 1: PRINT "%"
LOCATE 25, 30: PRINT "sem"
M = 0
LIMESC% = LIMESC
LOCATE 3, 1: PRINT LIMESC%
LOCATE 12, 1: PRINT "    -"
LIMINF% = LIMINF
LOCATE 22, 1: PRINT LIMINF%
LINE (40, 170)-(280, 20), , B
PSET (40, 170)
FOR J = 1 TO 51
DIVESC = 14 / 150
Z = Z + 4
IF J > 1 THEN GOTO 99500
LINE ((Z - 4), (170 - (CHTOT(J) - LIMINF) / DIVESC))-(Z, (170 - (CHTOT(J + 1) - LIMINF) / DIVESC)), 1

GOTO 101000

99500 LINE ((Z - 4), (170 - (ANT1 - LIMINF) / DIVESC))-(Z, (170 - (CHTOT(J + 1) - LIMINF) / DIVESC)), 1

101000 ANT1 = CHTOT(J + 1)

NEXT J
A = (170 - (CHTOT(J) - LIMINF) / DIVESC) / 8: B = Z / 8
LOCATE A, B: PRINT "CH TOT"
LOCATE 25, 1: PRINT "GRAFICO A IMPRESORA:^PRTSC"; : INPUT Q$
LOCATE 25, 1: INPUT Q$
SCREEN 0: WIDTH 80
GOTO 57000

110000
CLS : SCREEN 1
Z = 40: ANT1 = 0: LIMINF = 0: LIMESC = 11
LOCATE 3, 1: PRINT "mm"
LOCATE 25, 30: PRINT "sem"
M = 0
LIMESC% = LIMESC
LOCATE 3, 1: PRINT LIMESC%
LOCATE 12, 1: PRINT "    -"
LIMINF% = LIMINF
LOCATE 22, 1: PRINT LIMINF%
LINE (40, 170)-(280, 20), , B
PSET (40, 170)
FOR J = 1 TO 51
DIVESC = 11 / 150
Z = Z + 4
IF J > 1 THEN GOTO 110500
LINE ((Z - 4), (170 - (EVAPSEM(J) - LIMINF) / DIVESC))-(Z, (170 - (EVAPSEM(J + 1) - LIMINF) / DIVESC)), 1
GOTO 111000
110500 LINE ((Z - 4), (170 - (ANT1 - LIMINF) / DIVESC))-(Z, (170 - (EVAPSEM(J + 1) - LIMINF) / DIVESC)), 1

111000 ANT1 = EVAPSEM(J + 1)

NEXT J
A = (170 - (EVAPSEM(J) - LIMINF) / DIVESC) / 8: B = Z / 8
LOCATE A, B: PRINT "EV act"
LOCATE 25, 1: PRINT "GRAFICO A IMPRESORA:^PRTSC"; : INPUT Q$
LOCATE 25, 1: INPUT Q$
SCREEN 0: WIDTH 80
GOTO 57000

120000

CLS : SCREEN 1
Z = 40: ANT1 = 0: ANT2 = 0: ANT3 = 0: LIMINF = -8: LIMESC = 0
LOCATE 3, 1: PRINT "MPa"
LOCATE 25, 30: PRINT "sem"
M = 0
LIMESC% = LIMESC
LOCATE 3, 1: PRINT LIMESC%
LOCATE 12, 1: PRINT "    -"
LIMINF% = LIMINF
LOCATE 22, 1: PRINT LIMINF%
LINE (40, 170)-(280, 20), , B
PSET (40, 170)
FOR J = 1 TO 52
FOR I = 1 TO 3
CHMAX = (MAXCH(I, J) * 100) / EST(I)
CHMIN = (MINCH(I, J) * 100) / EST(I)
CHGRAF = (CHMAX + CHMIN) / 2
PTAG(I, J) = (EXP(CTE1(I) + CTE2(I) * CHGRAF)) * -1
NEXT I
NEXT J
FOR J = 1 TO 51
DIVESC = 8 / 150
Z = Z + 4
IF J > 1 THEN GOTO 120500
LINE ((Z - 4), (170 - (PTAG(1, J) - LIMINF) / DIVESC))-(Z, (170 - (PTAG(1, J + 1) - LIMINF) / DIVESC)), 1
LINE ((Z - 4), (170 - (PTAG(2, J) - LIMINF) / DIVESC))-(Z, (170 - (PTAG(2, J + 1) - LIMINF) / DIVESC)), 2
LINE ((Z - 4), (170 - (PTAG(3, J) - LIMINF) / DIVESC))-(Z, (170 - (PTAG(3, J + 1) - LIMINF) / DIVESC)), 3
GOTO 121000
120500 LINE ((Z - 4), (170 - (ANT1 - LIMINF) / DIVESC))-(Z, (170 - (PTAG(1, J + 1) - LIMINF) / DIVESC)), 1
LINE ((Z - 4), (170 - (ANT2 - LIMINF) / DIVESC))-(Z, (170 - (PTAG(2, J + 1) - LIMINF) / DIVESC)), 2
LINE ((Z - 4), (170 - (ANT3 - LIMINF) / DIVESC))-(Z, (170 - (PTAG(3, J + 1) - LIMINF) / DIVESC)), 3
121000 ANT1 = PTAG(1, J + 1)
ANT2 = PTAG(2, J + 1)
ANT3 = PTAG(3, J + 1)
NEXT J
A = (170 - (PTAG(1, J) - LIMINF) / DIVESC) / 8: B = Z / 8
LOCATE A, B: PRINT "LAY 1"
C = (170 - (PTAG(2, J) - LIMINF) / DIVESC) / 8: D = Z / 8
LOCATE C, D: PRINT "LAY 2"
C = (170 - (PTAG(3, J) - LIMINF) / DIVESC) / 8: D = Z / 8
LOCATE C, D: PRINT "LAY 3"
LOCATE 25, 1: PRINT "GRAFICO A IMPRESORA:^PRTSC"; : INPUT Q$
LOCATE 25, 1: INPUT Q$
SCREEN 0: WIDTH 80

GOTO 57000

140000
CLS : SCREEN 1
Z = 40: ANT1 = 0: ANT2 = 0: ANT3 = 0: LIMINF = -8: LIMESC = 0
LOCATE 3, 1: PRINT "MPa"
LOCATE 25, 30: PRINT "sem"
M = 0
LIMESC% = LIMESC
LOCATE 3, 1: PRINT LIMESC%
LOCATE 12, 1: PRINT "    -"
LIMINF% = LIMINF
LOCATE 22, 1: PRINT LIMINF%
LINE (40, 170)-(280, 20), , B
PSET (40, 170)
FOR J = 1 TO 52
FOR I = 4 TO 6
CHMAX = (MAXCH(I, J) * 100) / EST(I)
CHMIN = (MINCH(I, J) * 100) / EST(I)
CHGRAF = (CHMAX + CHMIN) / 2
PTAG(I, J) = (EXP(CTE1(I) + CTE2(I) * CHGRAF)) * -1
NEXT I
NEXT J
FOR J = 1 TO 51
DIVESC = 8 / 150
Z = Z + 4
IF J > 1 THEN GOTO 140500
LINE ((Z - 4), (170 - (PTAG(4, J) - LIMINF) / DIVESC))-(Z, (170 - (PTAG(4, J + 1) - LIMINF) / DIVESC)), 1
LINE ((Z - 4), (170 - (PTAG(5, J) - LIMINF) / DIVESC))-(Z, (170 - (PTAG(5, J + 1) - LIMINF) / DIVESC)), 2
LINE ((Z - 4), (170 - (PTAG(6, J) - LIMINF) / DIVESC))-(Z, (170 - (PTAG(6, J + 1) - LIMINF) / DIVESC)), 3
GOTO 141000
140500 LINE ((Z - 4), (170 - (ANT1 - LIMINF) / DIVESC))-(Z, (170 - (PTAG(4, J + 1) - LIMINF) / DIVESC)), 1
LINE ((Z - 4), (170 - (ANT2 - LIMINF) / DIVESC))-(Z, (170 - (PTAG(5, J + 1) - LIMINF) / DIVESC)), 2
LINE ((Z - 4), (170 - (ANT3 - LIMINF) / DIVESC))-(Z, (170 - (PTAG(6, J + 1) - LIMINF) / DIVESC)), 3
141000 ANT1 = PTAG(4, J + 1)
ANT2 = PTAG(5, J + 1)
ANT3 = PTAG(6, J + 1)
NEXT J
A = (170 - (PTAG(4, J) - LIMINF) / DIVESC) / 8: B = Z / 8
LOCATE A, B: PRINT "LAY 4"
C = (170 - (PTAG(5, J) - LIMINF) / DIVESC) / 8: D = Z / 8
LOCATE C, D: PRINT "LAY 5"
C = (170 - (PTAG(6, J) - LIMINF) / DIVESC) / 8: D = Z / 8
LOCATE C, D: PRINT "LAY 6"
LOCATE 25, 1: PRINT "GRAFICO A IMPRESORA:^PRTSC"; : INPUT Q$
LOCATE 25, 1: INPUT Q$
SCREEN 0: WIDTH 80

GOTO 57000

160000 CLS
RETURN


 

